function Pl1=l1prj(f,l1radius)
%  Computes the projection onto the l1 ball

l1thres=l1thresfind2(f,l1radius);
Pl1=s_thres(f,l1thres);


end



function l1thres = l1thresfind2(x,l1radius)


N = length(x);
k = (1:N)';
ax = abs(x);

xs = sort(ax, 'descend');
cxs = cumsum(xs);
pos = (cxs - k.*xs) < l1radius;

pos_lesser = find(pos==1);

if all(pos)
    l1thres=0;
else
    rho = pos_lesser(end);
    l1thres=1/rho * (sum(xs(1:rho))-l1radius);
end

end


function out=s_thres(x,thres)
out = x; out(abs(x)<thres) = 0;
out(abs(x)>=thres) = out(abs(x)>=thres) - sign(x(abs(x)>=thres))*thres;

end