function Pl1=l1weightedprj(x,w,l1radius)
%  Computes the projection onto the weighted l1 ball


w = abs(w);

if (norm(x.*w,1) <= l1radius)
    Pl1=x;
else
    N = length(x);
    ax = abs(x);
    
    NewVect=ax./w;
    [NewVectS,index] = sort(NewVect,'descend');
    
    axs=ax(index);
    ws=w(index);
    thres=(cumsum(ws.*axs)-l1radius)./cumsum(ws.^2);
    
    r=N;
    for nn=1:N
        DummyV1 = NewVectS(1:r) - thres(r);
        jj=find(DummyV1>=0);
        jstar=jj(end);
        if ( jstar == r )
            break;
        else
            r=jstar;
        end
    end
    
    theta=thres(r);
    p= axs(1:r) - theta*ws(1:r);
    p=[p;zeros(N-r,1)];
    p(index)=p;
    Pl1=sign(x).*p;
    
end